Type Beam
    X       as Integer
    Y       as Integer
    MaxVal  as Integer
    CurrVal as Integer
    Faktor  as Integer
    Crit    as Byte
    
    Declare Constructor(XPos as Integer, YPos as Integer, Max as  Integer, Curr as Integer, Faktor as Integer)
    Declare Sub G()
End Type

'###############################################################################
Constructor Beam(XPos as Integer, YPos as Integer, Max as  Integer, Curr as Integer, Scale as Integer)
    X       = XPos
    Y       = YPos
    MaxVal  = Max
    CurrVal = Curr
    Faktor  = Scale
End Constructor

'###############################################################################
Sub Beam.G()
    If CurrVal >= MaxVal / 4 then
        Line(X - 2, Y - 2) - (X + MaxVal * Faktor + 2, Y + 10 + 2), &h6060FF, BF
        Line(X , Y) - (X + CurrVal * Faktor, Y + 10), &h0000FF, BF
        Crit = 0
    Else
        Line(X - 2, Y - 2) - (X + MaxVal * Faktor + 2, Y + 10 + 2), &hFF6060, BF
        Line(X , Y) - (X + CurrVal * Faktor, Y + 10), &hFF0000, BF
        Crit = 1
    Endif
End Sub
